
IMPLEMENTATION MODULE    edcntl;

TYPE KBFlagSet = SET OF ( RShift, LShift, Ctrl, Alt, Scroll, Num, Cap, Ins ) ;

VAR  KeyFlags [40H:17H] : KBFlagSet ;



PROCEDURE       Steuerung; FORWARD;
PROCEDURE       Vorlauf( x0,y0,z0:  CARDINAL; Dokument:pzeile); FORWARD;
PROCEDURE       Nachlauf; FORWARD;
PROCEDURE       FensterOeffnen; FORWARD;



PROCEDURE       MTEXT( VAR x0,y0,z0:  CARDINAL; VAR Dokument:pzeile);
BEGIN
Vorlauf (x0,y0,z0, Dokument );
Steuerung;
Nachlauf;
END             MTEXT;



PROCEDURE       Vorlauf( x0,y0,z0:  CARDINAL; Dokument:pzeile);
VAR             i: CARDINAL;
BEGIN
ablage := NIL;
p:=NIL;
x:=1; y:= 1; z:=1; LinkerRand := 0;
FensterOeffnen;
Spalten := min ( WindowSpalten, MaxSpalten );
IF      Dokument <> NIL   THEN
	x      := min ( max(1,x0),  Spalten );
	anfang := Dokument; p:= anfang; i:= 1;
	WHILE (p^.n <> NIL )  AND (i < z0)   DO
	       INC(i); p:=p^.n;
	END;
	z:= min (i, max(1,z0));
	y:= min (max (1,y0),  min (z,WindowZeilen ) );
ELSE    Erzeugen( anfang, emptystring);  p := anfang;
END;
Laden;
END             Vorlauf;




PROCEDURE       Steuerung ;
VAR             AktiveBefehle: befehlsmenge;
		Befehl :  befehle;
		Eingabezeichen : CHAR;
BEGIN
AktiveBefehle   := befehlsmenge
		{NOCOM, INS,ENTER,
		UP, DOWN, LEFT, RIGHT,
		ControlLEFT, ControlRIGHT,
		PGUP, PGDOWN, ControlPGUP, ControlPGDOWN,
		HOME, ENDKEY, ControlHOME, ControlEND,
		F1,F2,F7,F8,F9,F10,
		DEL, BACKSPACE, ControlY,
		ControlK};
REPEAT
     Ausgabe;
     IF  Fehlerkontext <> 0  THEN
         HinweisAusgeben("F1=HELP") END;
     RdCom (Befehl, Eingabezeichen);
     IF  Befehl <> F1   THEN  Fehlerkontext := 0;  END;
     IF  Befehl IN AktiveBefehle   THEN
	 BefehlAusfuehren( Befehl, Eingabezeichen ) ;
     END;
UNTIL  Befehl = ESC;
END  Steuerung;




PROCEDURE       Nachlauf;
BEGIN
TextLoeschen (ablage );
IF      EdWindow <> NIL   THEN  Window.Close ( EdWindow )  END;
END             Nachlauf;




PROCEDURE       FensterOeffnen;
VAR             w: Window.WinType; wd:  Window.WinDef;
BEGIN
EdWindow :=NIL;
wd := Window.WinDef (
		0,0, Window.ScreenWidth-1,  Window.ScreenDepth-1,
		Window.Black, Window.LightGray,
		TRUE, TRUE, FALSE, TRUE,
		Window.DoubleFrame,
		Window.LightGray, Window.Black
		);
w := Window.Top();
IF      (w =NIL) OR ( NOT w^.WDef.FrameOn )  OR
	(w^.WDef.X2 - w^.WDef.X1 +1 < 3   )   OR
	(w^.WDef.Y2 - w^.WDef.Y1 +1 < 4   )
THEN    w := Window.Open( wd); EdWindow := w;
END;

WindowSpalten :=       w^.WDef.X2 - w^.WDef.X1 - 1 ;
	(* wg Rahmen *)
WindowZeilen  :=       w^.WDef.Y2 - w^.WDef.Y1 - 2 ;
	(* wg. Rahmen und Statuszeile  *)
END             FensterOeffnen;




PROCEDURE       Vorspann;

VAR
  IsBW : BOOLEAN ;

PROCEDURE CheckScrollLock () ;
BEGIN
  IF Scroll IN KeyFlags THEN
    Process.Lock ;
    WHILE Scroll IN KeyFlags DO
      Lib.Delay(10) ;
    END ;
    Process.Unlock ;
  END ;
END CheckScrollLock ;

PROCEDURE SetC ( cc,bwc : Window.Color ) ;
BEGIN
  IF IsBW THEN cc := bwc END ;
  Window.TextColor(cc) ;
END SetC ;



PROCEDURE Intro ;
(* Display startup and demonstration description *)

TYPE W   = RECORD x,y : CARDINAL END ;
     WW  = ARRAY[0..29] OF W ;
CONST
 ww = WW( W(0,0)  ,W(5,0) ,W(11,0),W(15,0),W(20,0),
          W(11,2) ,W(10,4),W(12,6),W(10,8),W(10,10),
          W(6,10) ,W(0,10),W(33,4),W(35,3),W(35,0),
          W(39,0), W(40,0),W(51,2),W(50,4),W(45,6),
          W(40,6), W(21,6),W(31,8),W(33,11),W(65,0),
          W(65,2), W(65,4),W(65,6),W(65,8),W(65,10)
        ) ;

PROCEDURE IntroText ;
BEGIN
  SetC(Window.White,Window.White);
  IO.WrLn;
  IO.WrLn;
  IO.WrStr('              Willkommen zur MTEXT-Demo !');
  IO.WrLn; IO.WrLn;
  IO.WrStr('      Mit [SCROLL LOCK] knnen Sie die Intro-Fenster "einfrieren". ');
  IO.WrLn;
  IO.WrStr('            Jede andere Taste startet MTEXT.'); IO.WrLn;
  IO.WrLn ;
END IntroText ;

VAR
   WD      : Window.WinDef ;
   w       : Window.WinType ;
   title   : ARRAY[0..39] OF CHAR ;
   Win     : ARRAY[0..29] OF Window.WinType ;
   i,j,wn  : CARDINAL ;
   num     : ARRAY[0..6] OF CHAR ;
   b,up    : BOOLEAN ;
   DescWin : Window.WinType ;
   delay   : CARDINAL ;
   exit,
   change  : BOOLEAN ;
CONST
   targetX = 32 ;
   targetY = 5 ;
BEGIN
  FOR i := 0 TO 29 DO
    WITH WD DO
      IF i<30 THEN
        IF IsBW THEN
          IF ODD(i) THEN
            Background := Window.Black ;
            Foreground := Window.White ;
          ELSE
            Background := Window.LightGray ;
            Foreground := Window.Black ;
          END ;
        ELSE
          Background := Window.Color(i MOD 8) ;
          Foreground := Window.Color(15-i MOD 8) ;
        END ;
        X1 := ww[i].x ; Y1 := ww[i].y ;
        X2 := X1+9 ;  Y2 := Y1+3 ;
      END ;
      CursorOn   := FALSE ;
      WrapOn     := FALSE ;
      Hidden     := FALSE ;
      FrameOn    := TRUE ;
      FrameDef   := Window.SingleFrame ;
      IF NOT IsBW AND (Background=Window.Black) THEN
        FrameBack  := Window.Green ;
      ELSE
        FrameBack  := Background ;
      END ;
      (* Window.Color(ORD(Foreground)MOD 8) *) ;
      IF FrameBack=Window.LightGray THEN FrameFore  := Window.Black ;
                                    ELSE FrameFore  := Window.LightGray ;
      END ;
    END ;
    Win[i] := Window.Open(WD) ;
    Window.SetTitle(Win[i],'MTEXT',Window.CenterUpperTitle);
    Str.CardToStr(LONGCARD(i+1),num,10,b) ;
    (*
    IF (i=29)OR(ww[i].x+5<>ww[i+1].x) THEN IO.WrChar(' '); END ;
    *)
    IO.WrStr(' Text- ');
    IO.WrLn ;
    IO.WrStr(' Editor');
  END ;
  WD := Window.WinDef(0,15,75,24,Window.White,Window.Black,
                      FALSE,TRUE,FALSE,TRUE,
                      Window.DoubleFrame,Window.Blue,Window.LightGray) ;
  IF IsBW THEN WD.FrameFore := Window.Black END ;
  DescWin := Window.Open(WD) ;
  Window.SetTitle(DescWin,' MTEXT: Ihr Modula2-Texteditor ',Window.CenterUpperTitle);
  IntroText ;
  delay := 1000 ;
  i := 0 ;
  WHILE NOT IO.KeyPressed() DO
    CheckScrollLock ;
    IF delay>100 THEN DEC(delay,20)
    ELSIF delay>1 THEN DEC(delay) ;
    END ;
    Lib.Delay(delay) ;
    Window.PutOnTop(Win[i]) ;
    i := (i+1)MOD 30 ;
  END ;
  REPEAT
    exit := TRUE ;
    FOR i := 0 TO 29 DO
      Window.Info(Win[i],WD) ;
      change := TRUE ;
      IF    WD.X1<targetX-3 THEN INC(WD.X1,3);INC(WD.X2,3);
      ELSIF WD.X1>targetX+3 THEN DEC(WD.X1,3);DEC(WD.X2,3);
      ELSIF WD.Y1=targetY THEN change := FALSE ;
      END ;
      IF    WD.Y1<targetY THEN INC(WD.Y1);INC(WD.Y2);
      ELSIF WD.Y1>targetY THEN DEC(WD.Y1);DEC(WD.Y2);
      END ;
      IF change THEN
         Window.Change(Win[i],WD.X1,WD.Y1,WD.X2,WD.Y2) ;
         exit := FALSE ;
      END ;
    END ;
  UNTIL exit ;
  FOR i := 0 TO 30 DO
    w := Window.Top() ;
    Lib.Delay(10) ;
    Window.Close(w) ;
   END ;
  IF IO.RdKey()=CHR(27) THEN HALT END ;
END Intro;


PROCEDURE CheckBW ;
VAR
  R : SYSTEM.Registers ;
BEGIN
     R.AH := 15 ;
     Lib.Intr(R,10H) ;
     IsBW := (R.AL = 0)OR(R.AL = 2)OR(R.AL = 5)OR(R.AL = 6)OR(R.AL = 7) ;
END CheckBW ;


BEGIN
  CheckBW ;
  Intro;
END Vorspann;



END edcntl.
