

IMPLEMENTATION  MODULE  edlistop;
    	
CONST         BufferSize = 10*512 + FIO.BufferOverhead;				
VAR           Puffer: ARRAY [0..BufferSize]  OF BYTE;



PROCEDURE    Erzeugen ( VAR  p: pzeile;  VAR  s: ARRAY OF CHAR  );
VAR     h: CARDINAL;
BEGIN
h:= Length( s);  NEW (p);  p^.v := NIL; p^.n := NIL;  p^.h := h;
ALLOCATE (p^.q, h+1 );   Move(ADR (s), p^.q,  h+1 );
END Erzeugen;



PROCEDURE    Freigeben ( p: pzeile );
BEGIN   DEALLOCATE (p^.q, p^.h +1 );  DISPOSE( p);
END Freigeben;



PROCEDURE    Linken (  x,y: pzeile );
BEGIN
IF      x <> NIL   THEN  x^.n := y   END;
IF      y <> NIL   THEN  y^.v := x   END;
END     Linken;



PROCEDURE    Speichern ( p : pzeile; VAR s:  ARRAY  OF CHAR  );
VAR     h: CARDINAL;
BEGIN   test ( p <>  NIL ,"Speichern");
DEALLOCATE (p^.q,  p^.h +1 );  h:= Length(s);   ALLOCATE (p^.q, h+1 );
Move ( ADR (s), p^.q, h+1 );   p^.h := h;
END     Speichern ;

PROCEDURE    Abspeichern; BEGIN  Speichern (p,s)  END Abspeichern;


PROCEDURE    Entladen (p: pzeile );
BEGIN        Move(p^.q, ADR(s), p^.h+1 );  END Entladen;


PROCEDURE    Laden;  BEGIN  Entladen(p) END Laden;




PROCEDURE    decp;
BEGIN   IF  p^.v = NIL   THEN RETURN END;
p:=  p^.v; DEC(z);  IF  y> 1  THEN DEC(y)  END;
END decp;



PROCEDURE    incp;
BEGIN   IF  p^.n = NIL   THEN RETURN END;
p:=  p^.n; INC(z);  IF  y < WindowZeilen  THEN INC(y)  END;
END incp;




PROCEDURE    ZeileVor;
BEGIN        Abspeichern; incp; Laden;  END ZeileVor;


PROCEDURE    ZeileZurueck;
BEGIN        Abspeichern; decp; Laden;  END ZeileZurueck;




PROCEDURE    Einfuegen (  p: pzeile;  VAR  s: ARRAY OF CHAR  );
VAR     pn, x: pzeile;
BEGIN
pn := p^.n;  Erzeugen (x,s );  Linken (p,x ); Linken (x,pn );
IF      x^.v = NIL    THEN  anfang := x;   END;
END     Einfuegen;




PROCEDURE    Loeschen ( VAR  p: pzeile );
VAR     pn,pv: pzeile;
BEGIN
IF      p    = NIL      THEN  RETURN  END;
IF      p^.n = NIL      THEN   Einfuegen (p, emptystring) END;
pv:=p^.v; pn:=p^.n;   Freigeben (p);  Linken (pv, pn );  p := pn;
IF      p^.v = NIL      THEN  anfang := p; END;
END Loeschen;




PROCEDURE    Verketten ( p: pzeile );
VAR     i: CARDINAL;pn,pnn: pzeile;  s2: string;
BEGIN
IF      (p = NIL )  OR  ( pn =  NIL  ) THEN    piepsen(2);  RETURN ; END;
pn:=p^.n; pnn:=p^.n^.n;
IF      NOT VerkettenMoeglich(p)  THEN RETURN END;
CountBlanks(pn,0,i);
IF      i> 0   THEN
	Copy (s2, pn^.q^ ); Delete(s2, 0, i ); Speichern( pn, s2 );
END;
Concat (s2, p^.q^, pn^.q^);  Speichern (p,s2);
Freigeben (pn ); Linken (p, pnn );
END     Verketten;



PROCEDURE    VerkettenMoeglich (p:pzeile): BOOLEAN;
VAR          i,j: CARDINAL;
BEGIN
IF           (p=NIL) OR ( p^.n = NIL )  THEN RETURN (FALSE) END;
CountBlanks(p,0,i);
RETURN       p^.h + p^.n^.h -i <= MaxSpalten;
END          VerkettenMoeglich;





PROCEDURE    Splitten ( p: pzeile;   x: CARDINAL );
VAR          s, teil1, teil2: string;   h: CARDINAL;
BEGIN   teil1 :=""; teil2:="";
Slice ( teil1, p^.q^, 0  , x-1        ); (*  x-1 >= 0  zeichen *)
Slice ( teil2, p^.q^, x-1, MaxSpalten ); (*  der rest ab position x-1 *)
Speichern (p, teil1 );  Einfuegen ( p, teil2 );  (* kein laden ! *)
END     Splitten;





PROCEDURE    ZeilenLoeschen ( a,b: pzeile );
VAR     x, xn, av, bn : pzeile; h: CARDINAL;
BEGIN
IF   ( a = NIL )  OR  (a^.v = NIL )    OR ( b= NIL )   OR ( b^.n =  NIL )
THEN    fehler ("ZeilenLoeschen ")   END;
av := a^.v;  bn := b^.n;  x := a;
WHILE ( x <> b ) AND ( x <> NIL ) DO xn := x^.n; Freigeben (x ); x:= xn;  END;
test( x= b, "ZeilenLoeschen");  Freigeben (b);  Linken (av, bn );
END     ZeilenLoeschen ;




PROCEDURE    TextEinfuegen ( p,a: pzeile );
VAR     x, xn, av, bn : pstring ; h: CARDINAL;
BEGIN
WHILE ( a <> NIL ) DO
	IF   NOT Storage.Available (10000)   THEN piepsen(0); RETURN; END;
	Einfuegen (p,a^.q^ );  p := p^.n;  a := a^.n ;
END;
END     TextEinfuegen ;




PROCEDURE    TextLinken (  p,a: pzeile );
VAR  pn:    pzeile;
BEGIN       (*  p <> NIL *)
IF    p = NIL  THEN  pn:=  NIL  ELSE pn := p^.n   END;
Linken (p,a );
WHILE a^.n <> NIL  DO  a := a^.n  END;
Linken (a, pn );
IF    a^.v =  NIL    THEN   anfang :=a  END;
END          TextLinken;



PROCEDURE    TextLoeschen ( VAR  a: pzeile );
VAR     an : pzeile ; h: CARDINAL;
BEGIN   WHILE ( a <> NIL   )  DO an := a^.n; Freigeben (a ); a:= an;  END;
a :=  NIL;
END     TextLoeschen ;



PROCEDURE       TextSchreiben ( Dateiname: ARRAY OF CHAR;
				DateiUeberschreiben:  BOOLEAN;
				Dokument: pzeile) ;
VAR             Datei:  FIO.File; BufferSize: CARDINAL;
		s: string; p: pzeile;  IOcheck, KeinPlatz: BOOLEAN;
BEGIN
FIO.OK:= TRUE;
IOcheck := FIO.IOcheck;   FIO.EOF := FALSE; FIO.IOcheck := FALSE;
IF      FIO.Exists ( Dateiname )   THEN
	IF      DateiUeberschreiben    THEN
		Datei := FIO.Open ( Dateiname );
	ELSE    Datei := FIO.Append ( Dateiname );
	END;
ELSE            Datei := FIO.Create ( Dateiname );
END;

IF      NOT  FIO.OK   THEN RETURN END;
	(* IO-fehler  muss das aufrufende programm behandeln *)
FIO.AssignBuffer ( Datei, Puffer );
p := Dokument;
WHILE ( p<> NIL)  AND  FIO.OK  DO
	FIO.WrStr ( Datei, p^.q^ );  FIO.WrLn (Datei); p :=p^.n;
END;

FIO.Close (Datei);
FIO.IOcheck := IOcheck;
END             TextSchreiben;





PROCEDURE       TextLesen ( Dateiname: ARRAY OF CHAR;
		       VAR  Dokument: pzeile);
VAR             Datei:  FIO.File; BufferSize,h: CARDINAL;
		s: string; x,xn: pzeile;  IOcheck, KeinPlatz: BOOLEAN;
BEGIN
IOcheck := FIO.IOcheck;   FIO.EOF := FALSE; FIO.IOcheck := FALSE;
Datei := FIO.Open ( Dateiname);
IF       NOT  FIO.OK  THEN  RETURN END;
	(* IO-Fehler mu das aufrufende programm behandeln *)
FIO.AssignBuffer ( Datei, Puffer );
FIO.RdStr (Datei, s); s[MaxSpalten]:=0C;
IF      FIO.EOF   THEN
	Erzeugen ( Dokument, emptystring);
ELSE    Erzeugen ( Dokument, s);         x:= Dokument;  	
        FIO.RdStr (Datei, s); s[MaxSpalten] :=0C;
	WHILE   (NOT  FIO.EOF )  AND Storage.Available(10000)  DO
	        Einfuegen (x,s);  x:=x^.n;
	        FIO.RdStr(Datei, s);  s[MaxSpalten] :=0C;
	END;
	IF      NOT Storage.Available ( 10000 )   THEN
		s:="Wg. Platzmangel Datei nicht ganz gelesen";
		Einfuegen ( x,s);
	END;
END;
FIO.Close (Datei);
FIO.IOcheck := IOcheck;
END             TextLesen;



PROCEDURE    top(): pzeile;
VAR     i: INTEGER;   t: pzeile;
BEGIN   t:= p;
FOR     i:= 1    TO  y-1  DO  t:=t^.v; test (t <> NIL, "top"); END;
RETURN  t;
END     top;


BEGIN
END     edlistop.



