IMPLEMENTATION MODULE FileSystem;

  (* IMPORT FIO;

  TYPE File = RECORD
                res : (done, notdone);
                fnr : FIO.File;
                buf : ARRAY [0..127] OF BYTE;
	      END; *)

  PROCEDURE Open(VAR f:File; n :ARRAY OF CHAR);
    BEGIN
      f.fnr := FIO.Open(n);
      IF FIO.IOresult()=0
      THEN
        FIO.AssignBuffer(f.fnr,f.buf);
        f.res:=done;
      ELSE
        f.res:=notdone;
      END;
    END Open;

  PROCEDURE Create(VAR f:File; n :ARRAY OF CHAR);
    BEGIN
      f.fnr := FIO.Create(n);
      IF FIO.IOresult()=0
      THEN
        FIO.AssignBuffer(f.fnr,f.buf);
        f.res:=done;
      ELSE
        f.res:=notdone;
      END;
    END Create;

  PROCEDURE Lookup(VAR f:File; n : ARRAY OF CHAR; b : BOOLEAN);
    BEGIN
      IF NOT b OR FIO.Exists(n)
      THEN Open(f,n);
      ELSE Create(f,n);
      END;
    END Lookup;

  PROCEDURE Close(VAR f:File);
    BEGIN
      FIO.Close(f.fnr);
      IF FIO.IOresult()=0
      THEN f.res:=done;
      ELSE f.res:=notdone;
      END;
    END Close;

  PROCEDURE SetModify(VAR f:File);
    BEGIN
    END SetModify;

  PROCEDURE Delete(fn : ARRAY OF CHAR; VAR f:File);
    BEGIN
      FIO.Erase(fn);
      IF FIO.IOresult()=0
      THEN f.res:=done;
      ELSE f.res:=notdone;
      END;
    END Delete;

  PROCEDURE Rename(f1, f2 : ARRAY OF CHAR; VAR f:File);
    BEGIN
      FIO.Rename(f1, f2);
      IF FIO.IOresult()=0
      THEN f.res:=done;
      ELSE f.res:=notdone;
      END;
    END Rename;

  PROCEDURE SetPos(VAR f : File; a, b:CARDINAL);
    BEGIN
      IF f.res # done THEN RETURN END;
      FIO.Seek(f.fnr, VAL(LONGCARD,b)+VAL(LONGCARD,a)*65536);
      IF FIO.IOresult() # 0 THEN f.res:=notdone END;
    END SetPos;

  PROCEDURE Length(VAR f : File; VAR a, b:CARDINAL);
    VAR p : LONGCARD;
    BEGIN
      IF f.res # done THEN a:=0; b:=0; RETURN END;
      p:=FIO.Size(f.fnr);
      a:=VAL(CARDINAL,p DIV 65536);
      b:=VAL(CARDINAL,p MOD 65536);
      IF FIO.IOresult() # 0 THEN f.res:=notdone END;
    END Length;

  PROCEDURE GetPos(VAR f : File; VAR a, b:CARDINAL);
    VAR p : LONGCARD;
    BEGIN
      IF f.res # done THEN a:=0; b:=0; RETURN END;
      p:=FIO.Size(f.fnr);
      a:=VAL(CARDINAL,p DIV 65536);
      b:=VAL(CARDINAL,p MOD 65536);
      IF FIO.IOresult() # 0 THEN f.res:=notdone END;
    END GetPos;

  PROCEDURE ReadNBytes(VAR f:File; A : ADDRESS; a:CARDINAL; VAR b:CARDINAL);
    BEGIN
      IF f.res # done THEN RETURN END;
      b:=FIO.RdBin(f.fnr,A^,a);
      IF FIO.IOresult() # 0 THEN f.res:=notdone END;
    END ReadNBytes;

  PROCEDURE WriteNBytes(VAR f:File; A : ADDRESS; a:CARDINAL; VAR b:CARDINAL);
    BEGIN
      IF f.res # done THEN b:=0; RETURN END;
      FIO.WrBin(f.fnr,A^,a);
      b:=a;
      IF FIO.IOresult() # 0 THEN f.res:=notdone; b:=0 END;
    END WriteNBytes;

  PROCEDURE ReadChar(VAR f:File; VAR C : CHAR);
    VAR a:CARDINAL;
    BEGIN
      IF f.res # done THEN RETURN END;
      ReadNBytes(f,ADR(C),SIZE(C),a);
      IF a # SIZE(C) THEN f.res:=notdone END;
    END ReadChar;

  PROCEDURE WriteChar(VAR f:File; C : CHAR);
    VAR a:CARDINAL;
    BEGIN
      IF f.res # done THEN RETURN END;
      WriteNBytes(f,ADR(C),SIZE(C),a);
      IF a # SIZE(C) THEN f.res:=notdone END;
    END WriteChar;

  PROCEDURE ReadWord(VAR f:File; VAR W : WORD);
    VAR a:CARDINAL;
    BEGIN
      IF f.res # done THEN RETURN END;
      ReadNBytes(f,ADR(W),SIZE(W),a);
      IF a # SIZE(W) THEN f.res:=notdone END;
    END ReadWord;

  PROCEDURE WriteWord(VAR f:File; W : WORD);
    VAR a:CARDINAL;
    BEGIN
      IF f.res # done THEN RETURN END;
      WriteNBytes(f,ADR(W),SIZE(W),a);
      IF a # SIZE(W) THEN f.res:=notdone END;
    END WriteWord;

BEGIN
  FIO.IOcheck:=FALSE;
END FileSystem.
