IMPLEMENTATION MODULE LOWFILES;

  FROM SYSTEM IMPORT BYTE,ADR;
  FROM Strings IMPORT Assign;
  FROM FileSystem IMPORT File, Open, Create, Close, done;
  IMPORT FileSystem;

(*
  TYPE LowFilePtr = POINTER TO LowFile;
       LowFile = RECORD
                   last,
                   next : LowFilePtr;
                   open : BOOLEAN;
                   fname : ARRAY [0..80] OF CHAR;
                   handle : File;
                 END;
       FilePos = LONGCARD;

  VAR FileHandles : CARDINAL;
  (* Standardwert: 12, kann vom Benutzer (vorsichtig!) manipuliert werden *)
*)

  VAR FileQueue : LowFilePtr;

  PROCEDURE AppendQueue(fptr : LowFilePtr);
    BEGIN
      WITH fptr^ DO
        IF FileQueue=NIL THEN
          next:=fptr;
          last:=fptr;
          FileQueue:=fptr;
        ELSE
          next:=FileQueue;
          last:=FileQueue^.last;
          last^.next:=fptr;
          next^.last:=fptr;
          FileQueue:=fptr;
        END;
      END;
    END AppendQueue;

  PROCEDURE DeleteQueue(fptr : LowFilePtr);
    BEGIN
      WITH fptr^ DO
        last^.next:=next;
        next^.last:=last;
        IF FileQueue=fptr THEN
          FileQueue:=next;
          IF FileQueue=fptr THEN FileQueue:=NIL END;
        END;
      END;
    END DeleteQueue;

  PROCEDURE DoLRU(VAR f : LowFile; VAR IO : INTEGER);
    VAR temp : BYTE;
    BEGIN
      IF f.open THEN
        IO:=0;
        DeleteQueue(ADR(f));
        AppendQueue(ADR(f));
      ELSIF FileHandles=0 THEN
	(* !!!!!! es ist mindestens ein
	   !!!!!! offenes File in der Queue *)
        WITH FileQueue^.last^ DO
          Close(handle); open:=FALSE;
          IO:=ORD(handle.res<>done);
        END;
        DeleteQueue(FileQueue^.last);
        AppendQueue(ADR(f));
        WITH f DO
          Open(handle,fname);
          IF handle.res<>done THEN IO:=1 END;
          open:=TRUE;
        END;
      ELSE
        DEC(FileHandles);
        AppendQueue(ADR(f));
        WITH f DO
          Open(handle,fname);
          IO:=ORD(handle.res<>done);
          open:=TRUE;
        END;
      END;
    END DoLRU;

  PROCEDURE FreeHandles(Count : CARDINAL; VAR IO : INTEGER);
    BEGIN
      IO:=0;
      WHILE (FileQueue<>NIL) AND ((Count=0) OR (FileHandles<Count)) DO
        WITH FileQueue^.last^ DO
          Close(handle); open:=FALSE;
          IF handle.res<>done THEN IO:=1 END;
        END;
        INC(FileHandles);
        DeleteQueue(FileQueue^.last);
      END;
    END FreeHandles;

  PROCEDURE CloseLowFile(VAR f : LowFile; VAR IO : INTEGER);
    BEGIN
      IF f.open THEN
        Close(f.handle); IO:=ORD(f.handle.res<>done);
        f.open:=FALSE;
        INC(FileHandles);
        DeleteQueue(ADR(f));
      ELSE IO:=0;
      END;
    END CloseLowFile;

  PROCEDURE ResetLowFile(VAR f : LowFile; name : ARRAY OF CHAR;
                         VAR IO : INTEGER);
    VAR temp : BYTE;
        IO2 : INTEGER;
    BEGIN
      FreeHandles(1,IO);
      WITH f DO
        Assign(name,fname);
        Open(handle,fname);
        open:=TRUE;
        IF handle.res<>done THEN IO:=1 END;
      END;
      DEC(FileHandles);
      AppendQueue(ADR(f));
      IF IO<>0 THEN CloseLowFile(f,IO2) END;
    END ResetLowFile;

  PROCEDURE RewriteLowFile(VAR f : LowFile; name : ARRAY OF CHAR;
                           VAR IO : INTEGER);
    VAR temp : BYTE;
        IO2 : INTEGER;
    BEGIN
      FreeHandles(1,IO);
      WITH f DO
        Assign(name,fname);
        Create(handle,fname);
        IF handle.res<>done THEN IO:=1 END;
        open:=TRUE;
      END;
      DEC(FileHandles);
      AppendQueue(ADR(f));
      IF IO<>0 THEN CloseLowFile(f,IO2) END;
    END RewriteLowFile;

  PROCEDURE ReadNBytes(VAR f : LowFile; ab : FilePos;
                       n : CARDINAL; VAR V : ARRAY OF BYTE;
                       VAR IO : INTEGER);
    VAR IO2 : INTEGER;
        m : CARDINAL;
        pos : RECORD
                CASE : BOOLEAN OF
                  | FALSE : val : LONGCARD;
                  | TRUE  : low, high : CARDINAL;
                END;
              END;

    BEGIN
      DoLRU(f,IO);
      IF IO=0 THEN
        pos.val:=ab;
        FileSystem.SetPos(f.handle,pos.high,pos.low);
        IO:=ORD(f.handle.res<>done);
        IF IO=0 THEN
          FileSystem.ReadNBytes(f.handle,ADR(V),n,m);
          IO:=ORD((f.handle.res<>done) OR (n<>m));
        END;
      END;
      IF IO<>0 THEN CloseLowFile(f,IO2) END;
    END ReadNBytes;

  PROCEDURE WriteNBytes(VAR f : LowFile; ab : FilePos;
                        n : CARDINAL; VAR V : ARRAY OF BYTE;
                        VAR IO : INTEGER);
    VAR IO2 : INTEGER;
        m : CARDINAL;
        pos : RECORD
                CASE : BOOLEAN OF
                  | FALSE : val : LONGCARD;
                  | TRUE  : low, high : CARDINAL;
                END;
              END;

    BEGIN
      DoLRU(f,IO);
      IF IO=0 THEN
        pos.val:=ab;
        FileSystem.SetPos(f.handle,pos.high,pos.low);
        IO:=ORD(f.handle.res<>done);
        IF IO=0 THEN
          FileSystem.WriteNBytes(f.handle,ADR(V),n,m);
          IO:=ORD((f.handle.res<>done) OR (n<>m));
        END;
      END;
      IF IO<>0 THEN CloseLowFile(f,IO2) END;
    END WriteNBytes;

BEGIN
  FileHandles:=12;
  FileQueue:=NIL;
END LOWFILES.
