MODULE TMouse;
(*$V-,I-,R-,S-*)

  FROM Mouse IMPORT eButtonState, eCursorType, eButtons, sButtons,
                    Reset, CursorOn, CursorOff,
                      Read, SetCursor,
                      InformButtonPressed, InformButtonReleased,
                      SetXScope, SetYScope,
                      DefineTextCursor, GetMickeys, SetMickeysPerPixel,
                      SetInvisScope, SetThreshold;
  FROM IO      IMPORT WrLn, WrStr, WrCard, WrInt;
  FROM Lib     IMPORT Delay;

  VAR nrButtons, nrPressed, nrReleased, x, y : CARDINAL;
      dx, dy                                 : INTEGER;
      pButtons, pButtonsOld                  : sButtons;
      buttonState                            : eButtonState;

  PROCEDURE move();
  BEGIN
    WrLn; WrStr('Move Mouse and press buttons (one ore more)');
    WrLn; WrStr('Cursor in right-down corner stops this test');
    WrLn;
    Read (pButtonsOld, x, y);
    InformButtonPressed  (right, buttonState, nrPressed, x, y);
    InformButtonReleased (left, buttonState, nrReleased, x, y);
    CursorOn;
    REPEAT
      Read (pButtons, x, y);
      IF (pButtons # pButtonsOld) THEN
        CursorOff;
        IF left IN pButtons THEN
          WrStr ('l');
        END;
        IF right IN pButtons THEN
          WrStr ('r');
        END;
        IF middle IN pButtons THEN
          WrStr ('m');
        END;
        IF pButtons = sButtons{} THEN
          WrStr ('all released at');
        END;
        WrCard(x,3); WrCard(y,3); WrLn;
        pButtonsOld := pButtons;
        CursorOn;
      END;
    UNTIL (x=79) AND (y=24);
    SetCursor (39, 12);
  END move;

BEGIN
  WrLn;
  IF NOT Reset (nrButtons) THEN
    WrStr ('No Mouse - Driver installed');
    HALT();
  ELSE
    WrStr ('Number of mouse Buttons:'); WrCard(nrButtons, 3);
  END;
  move();
  InformButtonPressed (right, buttonState, nrPressed, x, y);
  InformButtonReleased (left, buttonState, nrReleased, x, y);
  CursorOff;
  WrLn; WrStr ('You pressed the right one '); WrCard (nrPressed,5);
  WrStr (' times');
  WrLn; WrStr ('and released the left one '); WrCard (nrReleased,5);
  WrStr (' times.');
  WrLn; WrStr ('Position of last left release:'); WrCard(x,3); WrCard(y,3);
  SetCursor (10, 3);
  CursorOn;
  Read (pButtons, x, y);
  WrLn; WrStr ('Cursor Position now reset to '); WrCard(x,3); WrCard(y,3);
  Delay (2000);
  WrLn; WrStr ('(Press Button to continue)');
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Test of Scopes: x (40,75) y (3,6) (Press Button to continue)');
  SetXScope (40, 75);
  SetYScope (3, 6);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  SetXScope (0,79);
  SetYScope (0,24);
  WrLn; WrStr ('Test of TextCursorTypes (Press Buttons to change)');
  WrLn; WrStr ('Hard 12, 13:');
  DefineTextCursor (hard, 12, 13);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Hard 5, 6:');
  DefineTextCursor (hard, 5, 6);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  IF Reset (nrButtons) THEN END;
  Delay(500);
  DefineTextCursor (hard, 0FFH, 0H);
  WrLn; WrStr ('Soft 0FFFFH, 1H:');
  DefineTextCursor (soft, 0FFFFH, 1H);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Soft 0FFFFH, 144:');
  DefineTextCursor (soft, 0FFFFH, 144);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  IF Reset (nrButtons) THEN END;
  WrLn; WrStr ('GetMickeys (button to stop this test:');
  CursorOn;
  REPEAT
    GetMickeys (dx, dy);
    Delay(200);
    CursorOff;
    WrLn; WrInt (dx, 6); WrInt (dy, 6);
    CursorOn;
    Read (pButtons, x, y);
  UNTIL pButtons # sButtons{};
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Test SetMickeys (10,10)');
  SetMickeysPerPixel (10, 10);
  move();
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Test SetMickeys (100,100)');
  SetMickeysPerPixel (100, 100);
  move();
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Test SetMickeys (14,20)');
  SetMickeysPerPixel (14, 20);
  move();
  CursorOff;
  Delay(500);
  WrLn; WrStr ('Test of Double Speed Threshold: 500');
  WrLn; WrStr ('(Press Button to continue)');
  SetThreshold (500);
  CursorOn;
  REPEAT Read (pButtons, x, y) UNTIL pButtons # sButtons{};
  CursorOff;
END TMouse.
